using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Data.OleDb;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using RealLife1.DbDemosTableAdapters;
using System.Transactions;

namespace RealLife1
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        // le Dataset typ
        private DbDemos db = new DbDemos();
        
        // chargement de la fiche
        private void Form1_Load(object sender, EventArgs e)
        {
            LoadData();
        }

        // chargement des donnes
        private void LoadData()
        {
            customerTableAdapter c_da = new customerTableAdapter();
            c_da.Connection = DbDemosConnection;
            c_da.Fill(db.customer);
            ordersTableAdapter o_da = new ordersTableAdapter();
            o_da.Connection = DbDemosConnection;
            o_da.Fill(db.orders);
            itemsTableAdapter i_da = new itemsTableAdapter();
            i_da.Connection = DbDemosConnection;
            i_da.Fill(db.items);
            CustomersGrid.DataSource = db;
            CustomersGrid.DataMember = "customer";
            OrdersGrid.DataSource = db;
            OrdersGrid.DataMember = "customer.customerorders";
            ItemsGrid.DataSource = db;
            ItemsGrid.DataMember = "customer.customerorders.ordersitems";
        }
        
        // fermeture application
        private void close_Click(object sender, EventArgs e)
        {
            Application.Exit();
        }

        // clic sur le bouton de mise  jour
        private void maj_Click(object sender, EventArgs e)
        {
            // SaveData(); // avec gestion des transactions (non support par Access)
            UpdateData(); // sans transaction pour Access
        }

            // Mise  jour des donnes
            private void SaveData()
            {
                try
                {
                    using (TransactionScope scope = new TransactionScope())
                    {
                        UpdateData();
                        scope.Complete();
                    }
                }
                catch(TransactionAbortedException)
                {
                    MessageBox.Show("La mise  jour  choue !");
                }
            }

        private void UpdateData()
        {
            customerTableAdapter c_da = new customerTableAdapter();
            c_da.Connection = DbDemosConnection;
            c_da.Update(db.customer);
            ordersTableAdapter o_da = new ordersTableAdapter();
            o_da.Connection = DbDemosConnection;
            o_da.Update(db.orders);
            itemsTableAdapter i_da = new itemsTableAdapter();
            i_da.Connection = DbDemosConnection;
            i_da.Update(db.items);
        }

        private void charger_Click(object sender, EventArgs e)
        {
            db.Clear();
            LoadData();
        }
    }
}